#!/bin/bash

# Copyright (c) 1998-2002 B2C2, Incorporated.  All Rights Reserved.
#
# THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF B2C2, INCORPORATED.
# The copyright notice above does not evidence any
# actual or intended publication of such source code.
#
# This file is proprietary source code of B2C2, Incorporated. and is released pursuant to and
# subject to the restrictions of the non-disclosure agreement and license contract entered
# into by the parties.
 
#   Usage: b2settuner flags [options]
#
#   Note: Flags and options must be separated from values with blanks
#
#   Flags:
#   -a    Adapter name; e.g. eth1
#   -i    Tuner type; valid values are:
#         c (cable), s (satellite), t (terrestrial)
#   -f    Frequency (Transponder) in MHz (c, s); e.g. 350
#   -s    Symbol Rate in Ks/s (c, s); e.g. 6111
#   -m    Modulation in QAM (c); valid values are:
#         4, 16, 32, 64, 128, 256
#   -l    LNB Frequency in MHz (s); note: must be less than Transponder
#         Frequency specified with -f
#   -e    FEC (s); valid values are:
#         1/2, 2/3, 3/4, 5/6, 7/8, auto
#   -o    Polarity (s); valid values are: h (horizontal), v (vertical)
#   -k    LNB Selection in KHz(s); valid values are: 0, 22, 33, 44
#   -d    Diseqc (s); valid values are:
#         n (none), a, b, a/a, a/b, b/a, b/b
#   -pd   IP PID as integer or hex. (c, s); e.g. 164, 0xa4 or 0XA4.
#         For each IP PID, specify a separate -pd option;
#         e.g. -pd 17 -pd 18, etc.  Maximum # of PIDS supported: 32
#
#   Options:
#   -st   Skip Tuning
#   -ma   MAC address as 6 pairs of hex digits preceded with 0x;
#         e.g. 0x01005e010500
#   -t    Time in seconds to pause for data
#   -h    Help

set -x

./b2settuner -a eth1 -ma 0x01005e02f212 -i s -f 12426 -s 27500 -l 11250 -e auto -o h -k 22 -d b/a -pd 0x1212
