
// Copyright (c) 1998-2002 B2C2, Incorporated.  All Rights Reserved.
//
// THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF B2C2, INCORPORATED.
// The copyright notice above does not evidence any
// actual or intended publication of such source code.
//
// This file is proprietary source code of B2C2, Incorporated. and is released pursuant to and
// subject to the restrictions of the non-disclosure agreement and license contract entered
// into by the parties.

//
// File: b2dump.h
//
#ifndef __B2DUMP_H__
#define __B2DUMP_H__

#ifndef TRUE
#define TRUE 1
#endif
#ifndef FALSE
#define FALSE 0
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/timeb.h>
#include "linux_windefs.h"

#include "b2c2_defs.h"
#include "b2c2mpeg2adapter.h"
#include "ib2c2mpeg2datactrl.h"
#include "ib2c2mpeg2avctrl.h"

// Following for mmap flags
#include <sys/mman.h>

#include <errno.h>
#include <sys/ioctl.h>
#include <time.h>

// Struct used for processing command line arguments.
#define MAX_B2DUMP_TS_PIDS	39
#define MAX_B2DUMP_AV_PIDS	1
typedef struct
{	
	// Required arguments

	char			szAdapterName[128];
	bool			bAdapterNameSet;
	bool			bMonitorMode;		// Don't write to file
	bool			bVerboseMode;		// Be verbose

	long			lTotalTSPidsSpecified;
	long			lTSPidArray[MAX_B2DUMP_TS_PIDS];
	long			lTotalVidPidsSpecified;
	long			lVidPidArray[MAX_B2DUMP_AV_PIDS];
	long			lTotalAudPidsSpecified;
	long			lAudPidArray[MAX_B2DUMP_AV_PIDS];

	// Optional arguments

	char			szFilename[1024];
	long			lDumpDuration;

	// Used in processing above

	long			lSysPidSize;


	// Statistics
	DWORD dwTotalTsBytes;
	DWORD dwTotalAudBytes;
	DWORD dwTotalVidBytes;

} tSParams;


#define MAJOR_DEVICE_NAME	"/dev/B2C2AV"
#define DUMP_FILENAME		"./b2dump.data"
#define LOG_FILENAME		"./b2dump.log"

#define TS_SUFFIX			".TS"
#define AUD_SUFFIX			".AUD"
#define VID_SUFFIX			".VID"

#define BUFFER_SIZE			(1024UL*1024UL)

#define MINIMUM_ITTERATION_TIME	250    //  In milliseconds

enum eStreamType {
	TsStream,
	AudioStream,
	VideoStream
};

#define PKT_LEN		192
#define TS_PKT_LEN	188

class CStreamRec {
	const eStreamType		m_ThisStream;
    static B2C2MPEG2Adapter *      ms_pB2C2Adapter;
	static unsigned			ms_uInstanceCounter;
	FILE *					m_pStream;
	FILE *					m_pDump;
	unsigned short			m_usWrapCnt;
	unsigned int			m_uSecs;
	unsigned int			m_uLen;
	unsigned long			m_ulLastPos;
	//int						n;
	int						m_nOffset;
	unsigned char *			m_pucBaseAddr;
	long					m_lActivePid;

public:
    CStreamRec(eStreamType ThisStream, tSParams *pSParams);
	~CStreamRec();

	bool InterfacesCreated(void)
	{
		return NULL != ms_pB2C2Adapter;
	}


	long GetActivePid(void) const
	{
		return m_lActivePid;
	}

	int StartStream(const tSParams &SParams, const CStreamRec * pPartner = NULL);
	int ProcessStream(bool bWriteFile, bool bVerboseMode);		// Returns total bytes read
};

#endif

