/*
// Copyright (c) 1998-2002 B2C2, Incorporated.  All Rights Reserved.
//
// THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF B2C2, INCORPORATED.
// The copyright notice above does not evidence any
// actual or intended publication of such source code.
//
// This file is proprietary source code of B2C2, Incorporated. and is released pursuant to and
// subject to the restrictions of the non-disclosure agreement and license contract entered
// into by the parties.
*/

//
// File: linux_windefs.h
//

#ifndef _linux_windefs_h_
#define _linux_windefs_h_

#include <sys/types.h>

// Following used in interface files and need to expand to nothing

#define THIS_
#define PURE

// Following used in skyapp.h and needs to expand to nothing

#define __cdecl

// Linux equivalents of Windows types

typedef long STDMETHODIMP;
typedef int HRESULT;

// Linux equivalent of Windows COM interface declaration

#define STDMETHOD(Method)	long Method

// Following from WinError.h (as is)

#define S_OK					((HRESULT)0x00000000L)
#define S_FALSE					((HRESULT)0x00000001L)
#define _HRESULT_TYPEDEF_(_sc)	((HRESULT)_sc)
#define E_POINTER				_HRESULT_TYPEDEF_(0x80004003L)
#define E_INVALIDARG            _HRESULT_TYPEDEF_(0x80070057L)
#define E_FAIL					_HRESULT_TYPEDEF_(0x80004005L)
#define SUCCEEDED(Status)		((HRESULT)(Status) >= 0)
#define FAILED(Status)			((HRESULT)(Status)<0)
#define NOERROR					0

// Added by ALF

#define INVALID_HANDLE_VALUE	(HANDLE)-1

typedef void VOID;
typedef long long __int64;

typedef char TCHAR;
typedef unsigned char BOOL;
typedef unsigned long DWORD;

#undef max
#define max(a,b) ((a) > (b) ? (a) : (b))
#undef min
#define min(a,b) ((a) < (b) ? (a) : (b))

/* minimum signed 64 bit value */
#define _I64_MIN    (-9223372036854775807i64 - 1)
/* maximum signed 64 bit value */
#define _I64_MAX      9223372036854775807i64
/* maximum unsigned 64 bit value */
#define _UI64_MAX     0xffffffffffffffff

#if !defined TEXT
	#define TEXT(s)	s
#endif

#if !defined _T
	#define _T(s)	s
#endif

// Added by ALF - END

#endif // _linux_windefs_h_
